<template>
    <div class="config">
        <div class="inputList">
            <div class="inpt">
                <label for="">
                    PassData
                    <input v-model="currentItem.passData" type="text" required>
                </label>
            </div>
            <div class="inpt">
                <label for="">
                    Degree
                    <input v-model="currentItem.degree" type="text" required>
                </label>
            </div>
            <div class="inpt">
                <label>
                    Specialization
                    <input v-model="currentItem.specialization" type="text" required>
                </label>
            </div>
            <div class="inpt">
                <label for="">
                    Position
                    <input v-model="currentItem.position" type="text" required>
                </label>
            </div>
            <div class="inpt">
                <label for="">
                    Salary
                    <input v-model="currentItem.salary" type="text" required>
                </label>
            </div>
        </div>
        <div class="btns">
            <button class="button primary" @click="onAction">{{ actionBtnText }}</button>
            <button v-if="itemId" class="button danger" @click="onDelete(currentItem.id)">Delete</button>
        </div>
    </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
export default {
    name: 'ConfigEmployee',
    data() {
        return {
            currentItem: {
                passData: '',
                degree: '',
                specialization: '',
                position: '',
                salary: '',
            },
        }
    },
    computed: {
        ...mapGetters('employees', ['getItemById']),
        itemId() {
            return this.$route.params.itemId
        },
        actionBtnText() {
            return this.itemId ? 'Save changes' : 'Create item'
        }
    },
    watch: {
        '$route.params.itemId': {
            handler(newItemId) {
                if (!newItemId) {
                    this.currentItem = {
                        passData: '',
                        degree: '',
                        specialization: '',
                        position: '',
                        salary: '',
                    };
                } else {
                    this.currentItem = { ...this.getItemById(newItemId) };
                }
            },
            immediate: true,
        },
    },
    methods: {
        ...mapActions('employees', ['addItem', 'updateItem', 'deleteItem']),
        onAction() {
            if (!this.itemId) {
                this.addItem(this.currentItem)
                    .then(() => {
                        this.$router.push({ name: 'employees' });
                    })
                    .catch((error) => {
                        console.error(error);
                    });
            } else {
                this.updateItem({ itemId: this.itemId, data: this.currentItem })
                    .then(() => {
                        this.$router.push({ name: 'employees' });
                    })
                    .catch((error) => {
                        console.error(error);
                    });
            }
        },
        onDelete(deleteRecipeId) {
            this.deleteItem(deleteRecipeId),
                this.$router.push({ name: 'employees' })
        },
    },
}
</script>

<style lang="scss" scoped>
.config {
    max-width: 600px;
    margin: 0 auto;
    padding: 20px;
    background-color: #f5f5f5;
    border-radius: 10px;
    box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
}

.inputList {
    display: flex;
    flex-direction: column;
    gap: 10px;
}

.inpt label {
    display: block;
    margin-bottom: 5px;
    font-weight: bold;
    color: black;
}

.inpt input {
    width: 100%;
    padding: 8px;
    border: 1px solid #ccc;
    border-radius: 5px;
}

.btns {
    display: flex;
    justify-content: space-between;
    margin-top: 20px;
}

.button {
    padding: 10px;
    border: none;
    border-radius: 5px;
    cursor: pointer;
    font-weight: bold;
    transition: background-color 0.3s ease;
}

.button.primary {
    background-color: #3498db;
    color: #fff;
}

.button.danger {
    background-color: #e74c3c;
    color: #fff;
}
</style>
